11 Setembro 2023 - #ASCN

## Complex Structures: Challenges
### Deployment
- Multiple components with specific requirements
- Heterogeneous hardware, software and services (e.g., cloud computing services

### Management + Configuration
- Specific to each software/hardware component
- Optimal configurations will change over time...

### Monitoring + Benchmarking
- Finding anomalies (performance, failures, ...) in complex applications and infrastructures 


## Agile Development
**Quick reaction to frequent small changes!**

- Rests on formal (versioned) source, binary and documentation repositories
	- Unambiguous current state
	- Ability to back track
- Automated build and test
	- Fast feedback
- Fast iterations

## Operations
- Manual provisioning and configuration
- Informal communication between qualification and production stages
- Consequences:
	- Not repeatable or reproducible
	- Configuration drift
	- “Snowflake” servers (don't even look at it…)
	- Subjective monitoring

## Infrastructure as Code
**Include infrastructure scripts in agile process!**

- Hardware provisioning with scripts
	- In contrast to: physically unboxing and plugging
- Software provisioning with scripts
	- In contrast to: clicking through setup wizards
- Configuration with scripts
	- In contrast to: clicking through control panels


## DevOps
**Supports fast, frequent, small changes!**

- Development and deployment are self-documenting and versioned
- Deployment is reproducible and repeatable
- Servers are disposable and consistent

## Roadmap
- Distributed systems architectures & deployment
	- Common distribution patterns
	- Reliability and scalability
	- Automatic provision and configuration
- Cloud computing
	- Services and abstractions
	- Infrastructure management (virtualization, storage, ...)
- Monitoring and evaluation
	- Monitoring frameworks and metrics
	- Benchmarking


